'use server';
import { NextResponse } from 'next/server';
import { GraphQLClient, gql } from 'graphql-request';
import { personAddSchema } from './schema';

const endpoint = "http://localhost:3001/graphql";

export async function POST(request: Request) {
    const body = await request.json();
    const validatedBody = personAddSchema.parse(body);
    try {
        const client = new GraphQLClient(endpoint);
        const query = gql`
            mutation CreatePerson($input: CreatePersonInput!) {
                createPerson(input: $input) {
                    uuid
                    firstName
                    surname
                    birthDate
                }
            }
        `;
        const variables = { input: validatedBody };
        const data = await client.request(query, variables);
        return NextResponse.json({ data: data.createPerson, status: 200 });
    } catch (err: any) {
        console.error(err);
        return NextResponse.json({ error: err.message }, { status: 500 });
    }
}

// export async function POST(request: Request) {

//     const body = await request.json();
//     const validatedBody = userAddSchema.parse(body);
//     console.log("VALIDATED")
//     console.dir({ validatedBody })
//     return NextResponse.json({ data: validatedBody })
// }
